// addseidataDlg.h : header file

#pragma once

#define NEWFILEIO__ 
//#define SHOWDISPLAYTIME

#define _CRT_SECURE_NO_DEPRECATE


#define MAX_IX  1000
#define MAX_POC 2000
#define H264_SYNC_BYTE 0x00000001
//#define MAX_BUFFER 132768
#define MAX_BUFFER 0xFFFF
#define SMALL_BUFFER 2047

#define SLICE_TYPE_P 0   // P (P slice)
#define SLICE_TYPE_B 1   // B (B slice)
#define SLICE_TYPE_I 2   // I (I slice)
#define SLICE_TYPE_SP 3  // SP (SP slice)
#define SLICE_TYPE_SI 4  // SI (SI slice)
#define SLICE_TYPE_P2 5  // P (P slice)
#define SLICE_TYPE_B2 6  // B (B slice)
#define SLICE_TYPE_I2 7  // I (I slice)
#define SLICE_TYPE_SP2 8 // SP (SP slice)
#define SLICE_TYPE_SI2 9 // SI (SI slice)

//#include ".\mpeg4ip_bitstream.h"
//#include "mpeg4ip_bitstream.h"
//#include "afxwin.h"
//#include "afxcmn.h"

// CaddseidataDlg dialog
class CaddseidataDlg : public CDialog
// class CaddseidataDlg  
{

/*
// Construction
public:
	CaddseidataDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_ADDSEIDATA_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
*/

public:
	explicit CaddseidataDlg(void) {;}	// added standard constructor
	bool init(int argc, char* __argv[]) ;   // added init replacing OnInitDialog()

	__int32_t *RealPoc;

	FILE * pOutputFile;
	FILE * pInputFile;
	void OnBnClickedButton1();
	CString c_InputFileName;
	CString c_OutputFileName;
	int AddLogLine( int level, CString LogText);
	bool h264_find_next_start_code(void);  
	bool eof;
	bool automode;
	unsigned int Inputgetbyte(void);
	int h264_parse_nal(void);
	int h264_parse_sei(void);
	CListBox m_List3;
//	afx_msg void OnLbnSelchangeList1();
	int bits;
	uint32_t getbits(int count);
	unsigned char thisbyte;
	int failsafecounter;
	int h264_parse_sequence_parameter_set(void);
	uint32_t h264_ue(void);
	__int32_t h264_se(void);
	uint32_t lookahead(int count);
	bool written_sps;
	bool have_sps_data;
	bool is_vc1_stream;
	bool full_log;
	bool log_to_file;

	

	//***** h264 variables
	uint32_t last3bytes;
	uint32_t sei_last3bytes;
	uint32_t last3bytesread;
	uint32_t nal_unit_type;
	uint32_t primary_pic_type;
	int add_aspect_ratio;
	bool negativepocadjusted;
	bool has_nal_type_access_unit;
	bool has_buffering_period;
	bool has_sei;
	bool has_pan_scan_rect;
	bool has_picture_timing;
	bool has_recovery_point;
	int  has_filler_data;
	bool ThisAuHasSps;
	bool write03;
	bool sliceread;
	bool noTimingSei;
	__int32_t count_03;
	FILE * pLogfile;
	bool bLogfileopen;
	int iLogfilewritecount;
	int forced_nal_params;
	__int64_t PrevPBframedec;
	bool updatePrevPB;
	__int64_t completedFrames;
	__int64_t FrameRate;
	bool addpicstruct;
	bool pps_every_picture;
	bool addtimecode;
	bool MustDoCpbCalc;
	__int64_t framesSoFar;
	__int64_t adjustedframesSoFar;
	__int32_t halfframesSoFar;
	__int32_t add_pulldown;
	__int32_t add_level;
	int     add_height;
	int     add_width;
	int     add_maxbitrate;
	unsigned int add_crop_top;
	unsigned int add_crop_bottom;
	unsigned int add_crop_left;
	unsigned int add_crop_right;	
	__int32_t add_num_ref_frames;	
	int convert_hdtobr;

	uint8_t access_unit_nal_ref_idc;
	uint32_t slice_nal_ref_idc;
	uint32_t slice_nal_type;
	uint32_t last_slice_nal_type;
	uint32_t sequence_parameter_set_ref_idc;
	uint32_t pic_parameter_set_ref_idc;
	uint32_t sei_nal_ref_idc;
	uint32_t write_time_offset_length;
	uint32_t write_initial_cpb_removal_delay_length_minus1;
	uint32_t write_cpb_removal_delay_length_minus1;
	uint32_t write_dpb_output_delay_length_minus1;
	unsigned     int write_pic_order_present_flag;

	uint8_t exp_golomb_bits_write[256];

	uint32_t profile;
	int constraint_set0_flag;
	int constraint_set1_flag;
	int constraint_set2_flag;
	int constraint_set3_flag;
	int level_idc;
	int seq_parameter_set_id_sps;
	int chroma_format_idc;
	int residual_colour_transform_flag;
	int bit_depth_luma_minus8;
	int bit_depth_chroma_minus8;
	int qpprime_y_zero_transform_bypass_flag;
	int seq_scaling_matrix_present_flag;
	int Seq_Scaling_List[MAX_IX];

	__int32_t *deltaScale;

	int log2_max_frame_num_minus4;
	int pic_order_cnt_type;

	int log2_max_pic_order_cnt_lsb_minus4;
	int delta_pic_order_always_zero_flag;
	__int64_t offset_for_non_ref_pic;
	__int64_t offset_for_top_to_bottom_field;
	int offset_for_ref_frame_count;
	__int64_t offset_for_ref_frame[MAX_IX];
	int num_ref_frames;
	int gaps_in_frame_num_value_allowed_flag;
	int pic_width_in_mbs_minus1;
	int pic_height_in_map_minus1;
	int frame_mbs_only_flag;
	int orig_frame_mbs_only_flag;
	int mb_adaptive_frame_field_flag;
	int direct_8x8_inference_flag;
	int frame_cropping_flag;
	int frame_crop_left_offset;
	int frame_crop_right_offset;
	int frame_crop_top_offset;
	int frame_crop_bottom_offset;
	int vui_parameters_present_flag;

	//***** vui params variables
	__int64_t NalHrdBpPresentFlag;
	__int64_t CpbDpbDelaysPresentFlag;
	double CpbRemovalDelay;
	int		CpbRemovalDelayOffset;
	int		LastNonBPicStruct;
	double CpbRemovalDelay2;
	__int64_t DpbOutputDelay;
	__int64_t VclHrdBpPresentFlag;
	
	int aspect_ratio_info_present_flag;
	int aspect_ratio_idc;
	int sar_width;
	int sar_height;
	int overscan_info_present_flag;
	int overscan_appropriate_flag;
	int video_signal_info_present_flag;
	int video_format;
	int video_full_range_flag;
	int colour_description_present_flag;
	int colour_primaries;
	int transfer_characteristics;
	int matrix_coefficients;
	int chroma_loc_info_present_flag;	
	int chroma_sample_loc_type_top_field;
	int chroma_sample_loc_type_bottom_field;
	int timing_info_present_flag;
	int num_units_in_tick;
	uint32_t time_scale;
	int fixed_frame_rate_flag;
	int nal_hrd_parameters_present_flag;
	int nal_hrd_parameters_present_in_source;
	int vcl_hrd_parameters_present_flag;
	int low_delay_hrd_flag;
	int pic_struct_present_flag;
    int bitstream_restriction_flag;
	int motion_vectors_over_pic_boundaries_flag;
	int max_bytes_per_pic_denom;
	int max_bits_per_mb_denom;
	int log2_max_mv_length_horizontal;
	int log2_max_mv_length_vertical;	
	int num_reorder_frames;
	int max_dec_frame_buffering;

	//hrd params
	int cpb_cnt_minus1;
	int bit_rate_scale;
	int cpb_size_scale;
	uint32_t bit_rate_value_minus1[MAX_IX];
	uint32_t cpb_size_value_minus1[MAX_IX];
	__int8_t  cbr_flag[MAX_IX];
	int initial_cpb_removal_delay_length_minus1;
	int cpb_removal_delay_length_minus1;
	int dpb_output_delay_length_minus1;
	int time_offset_length;

	int pic_parameter_set_id;
	int seq_parameter_set_id;
	int entropy_coding_mode_flag;
	int pic_order_present_flag;
	int num_slice_groups;
	int slice_group_map_type;
	int run_length_minus1[MAX_IX];
	int top_left[MAX_IX];
	int bottom_right[MAX_IX];
	int slice_group_change_direction_flag;
	int slice_group_change_rate_minus1;
	int pic_size_in_map_units_minus1;
	int slice_group_id[MAX_IX];
	int num_ref_idx_l0_active_minus1;
	int num_ref_idx_l1_active_minus1;
	int num_ref_idx_l0_active_minus1_override;
	int num_ref_idx_l1_active_minus1_override;
	int weighted_pred_flag;
	int weighted_bipred_idc;
	__int32_t pic_init_qp_minus26;
	__int32_t pic_init_qs_minus26;
	__int64_t chroma_qp_index_offset;
	int deblocking_filter_control_present_flag;
	int constraint_intra_pred_flag;
	int redundant_pic_cnt_present_flag;
	int transform_8x8_mode_flag;
	int pic_scaling_matrix_present_flag;
	int Pic_Scaling_List[MAX_IX];
	__int64_t second_chroma_qp_index_offset;

	int seq_parameter_set_id_sei;
	int initial_cpb_removal_delay[MAX_IX];
	int initial_cpb_removal_delay_offset[MAX_IX];

	int cpb_removal_delay;
	int dpb_output_delay;
	int pict_struct;
	int clock_timestamp_flag[MAX_IX];
	int ct_type[MAX_IX];
	int nuit_field_base_flag[MAX_IX];
	int counting_type[MAX_IX];
	int full_timestamp_flag[MAX_IX];
	int discontinuity_flag[MAX_IX];
	int cnt_dropped_flag[MAX_IX];
	int n_frame[MAX_IX];
	int seconds_value[MAX_IX];
	int minutes_value[MAX_IX];
	int hours_value[MAX_IX];
	int seconds_flag[MAX_IX];
	int minutes_flag[MAX_IX];
	int hours_flag[MAX_IX];
	int time_offset[MAX_IX];

	__int64_t pan_scan_rect_id;
	__int64_t pan_scan_rect_cancel_flag;
	__int64_t pan_scan_cnd_minus1;
	__int64_t pan_scan_rect_left_offset[MAX_IX];
	__int64_t pan_scan_rect_right_offset[MAX_IX];
	__int64_t pan_scan_rect_top_offset[MAX_IX];
	__int64_t pan_scan_rect_bottom_offset[MAX_IX];
	__int64_t pan_scan_rect_repitition_period;

	int recovery_frame_cnt; 
	int exact_match_flag;
	int broken_link_flag;
	int changing_slice_group_idc;
	
	__int64_t original_idr_flag;
	__int64_t original_frame_num; 
	__int64_t original_field_pic_flag;
	__int64_t original_bottom_field_flag;

	__int64_t target_frame_num;
	__int64_t spare_field_flag;
	__int64_t target_bottom_field_flag;
	__int64_t num_spare_pics_minus1;

	__int64_t scene_info_present_flag;
	__int64_t scene_id;
	__int64_t scene_transition_type;
	__int64_t second_scene_id;

	// slice
	int first_mb_in_slice;
	int slice_type;
	int pic_parameter_set_id_slice_header;
	int frame_num;
	int field_pic_flag;
	int bottom_field_flag;
	uint32_t idr_pic_id;
	int pic_order_cnt_lsb;
	__int64_t pic_order_cnt_msb;
	__int64_t prev_pic_order_cnt_lsb;
	__int64_t prev_pic_order_cnt_msb;
	__int64_t max_pic_order_cnt_lsb; 
	__int64_t top_field_order_cnt;
	__int64_t bottom_field_order_cnt;
	__int32_t delta_pic_order_cnt_bottom;
	__int64_t delta_pic_order_cnt[2];
	int redundant_pic_cnt;
	int direct_spatial_mv_pred_flag;
	int num_ref_idx_active_override_flag;
	int cabac_init_idc;
	__int64_t slice_qp_delta;
	int sp_for_switch_flag;
	__int64_t slice_qs_delta;
	int disable_deblocking_filter_idc;
	__int64_t slice_alpha_c0_offset_div2;
	__int64_t slice_beta_offset_div2;
	int slice_group_change_cycle;
	/*int PrevPframenum;
	int PrevBframenum;
	int PrevPframedec;
	int PrevBframedec;*/

	//ref_pic_list_reordering
	int ref_pic_list_reordering_flag_l0;
	int ref_pic_list_reordering_flag_l1;
	int reordering_of_pic_nums_idc[20];
	int reordering_of_pic_nums_val[20];
	__int64_t abs_diff_pic_num_minus1;
	__int64_t long_term_pic_num;

	//dec_ref_pic_marking
	int no_output_of_prior_pics_flag;
	int long_term_reference_flag;
	__int64_t adaptive_ref_pic_marking_mode_flag;
	__int64_t memory_management_control_operation;
	int memory_management_control_idc[20];
	int memory_management_control_val[20];
	__int64_t difference_of_pic_nums_minus1;	
	__int64_t long_term_frame_idx;
	__int64_t max_long_term_frame_idx_plus1;

	//pred_weight_table
	int luma_log2_weight_denom;
	int chroma_log2_weight_denom;
	__int64_t luma_weight_l0_flag[MAX_IX];
	__int64_t luma_weight_l0[MAX_IX];
	__int64_t luma_offset_l0[MAX_IX];
	int chroma_weight_l0_flag[MAX_IX];
	__int64_t chroma_weight_l0[MAX_IX*3+3];
	__int64_t chroma_offset_l0[MAX_IX*3+3];
	int luma_weight_l1_flag[MAX_IX];
	__int64_t luma_weight_l1[MAX_IX];
	__int64_t luma_offset_l1[MAX_IX];
	int chroma_weight_l1_flag[MAX_IX];
	__int64_t chroma_weight_l1[MAX_IX*3+3];
	__int64_t chroma_offset_l1[MAX_IX*3+3];

	__int64_t seq_parameter_set_id_ext;
	__int64_t aux_format_idc;
	int bit_depth_aux_minus8;
	__int64_t alpha_incr_flag;
	__int64_t alpha_opaque_value;
	__int64_t alpha_transparent_value;
	__int64_t additional_extension_flag;
	__int64_t FrameNumOffset;
	int Log2MaxFrameNumOffset;
	__int64_t PrevFrameNum;

	bool firstwrite;
	uint8_t writebit;
	uint8_t sei_writebit;
	uint32_t writebyte;
	uint32_t sei_writebyte;

	// file buffer
	__int64_t fposfile; //fpos_t
	__int64_t fposbuffer; //fpos_t
	__int64_t  buf_size;
	unsigned char* buf_fbuffer;
	bool buf_eof;

	__int64_t wfposfile;
	__int64_t wfposbuffer;
	__int64_t wbuf_size;
	unsigned char* wbuf_fbuffer;
	bool wbuf_eof;

	size_t sei_count_03;
	bool sei_firstwrite;
	bool sei_write03;
	size_t sei_pos;

	uint8_t exp_golomb_bits[256];
	
	//*****
	bool vc1_find_next_start_code(void);

	void h264_write_filler_data(void);
#ifndef NEWFILEIO__
	void h264_vui_parameters(void);
	void h264_hrd_parameters(void);
	void pred_weight_table(void);
	void ref_pic_list_reordering(void);
	void dec_ref_pic_marking(void);
#else
	void h264_vui_parameters( CBitstream *bs );
	void h264_hrd_parameters( CBitstream *bs );
	void pred_weight_table( CBitstream *bs );
	void ref_pic_list_reordering( CBitstream *bs );
	void dec_ref_pic_marking( CBitstream *bs );
	__int64_t emulationpreventionfill( CBitstream *bs );
#endif	
	unsigned char processdialogmessagesdelay;
	uint32_t GetBits(int count);	
	void scaling_list(uint32_t ix, uint32_t sizeofScalingList);
	void scaling_list_write(uint32_t ix, uint32_t sizeofScalingList);
	void OnCancel();
	void h264_parse_pic_parameter_set(void);
	uint32_t calc_ceil_log2(uint32_t val);
	uint64_t lookaheadnextstartcode(void);
	uint32_t h264_ue(CBitstream *bs);
	__int32_t h264_se(CBitstream *bs);
	void h264_slice_layer_without_partitioning(void);
	void h264_slice_header(void);
	void h264_parse_seq_ext(void);
	void h264_write_picture_sequence(void);
	void h264_write_access_unit_delimiter(void);
	void PutBits( uint32_t value, __int32_t bitlength);
	void putbit( uint8_t value );
	// fills bits using putbits (get us back even to byte)
	void FillBits(int value);
	void h264_write_sequence_parameter_set(void);
	void putbits_ue( uint32_t value );
	void putbits_se( __int32_t value);
	void h264_vui_parameters_write(void);
	void h264_hrd_parameters_write(void);
	void h264_write_pic_parameter_set(void);
	void h264_write_sei(int beforeslice, int fillersize);
	void resetvariables(void);
	void PutSyncByte(void);
	void h264_write_slice_header(void);
	void FillRemainderUntilSync(void);
	void h264_write_EOS(void);	
	void h264_write_ref_pic_list_reordering(void);	
	void h264_write_pred_weight_table(void);	
	void h264_write_dec_ref_pic_marking(void);
	__int64_t CurrentFrame (__int64_t temporalDisplay, __int64_t completedFrames) ;
	int tbt_bt(int currentframe, int pulldown_mode);
	__int64_t pictstruct(int tbt);
	void resetseivariables(void);
	unsigned int numclockts(int pstruct);
	void rbsp_trailing_bits(void);
	bool byte_aligned(void);
	bool firsttickset;
	bool bStopLoop;
	bool bLastNalReadUntilSync;

	FILE* buf_fopen(const char* filename, const char* attribs);
	
	void buf_fclose(FILE* stream);
	__int64_t buf_ftelli64(FILE* stream);
	void buf_fseeki64(FILE* stream, __int64_t location, int seekfrom);
	FILE* wbuf_fopen(const char* filename, const char* attribs);
	__int64_t wbuf_ftelli64(FILE* stream);
	void wbuf_fseeki64(FILE* stream, __int64_t location, int seekfrom);
	void wbuf_fclose(FILE* stream);
	void PutBits(unsigned char* buffer, uint32_t value, uint32_t count);
	void putbit(unsigned char* buffer, uint8_t value);
	void putbits_ue(unsigned char* buffer, uint32_t value);
	void put_bits_se(unsigned char* buffer, __int32_t value);
	void rbsp_trailing_bits(unsigned char* buffer);
	bool sei_byte_aligned(void);

//	afx_msg void OnBnClickedInputBtn();
	CEdit c_InputFile;
	CEdit c_OutputFile;
	bool ProcessDialogMessages(void);
	CButton c_Pulldown;
	CButton c_RemovePulldown;
	CButton c_HDtoBR;
	CButton c_AddPicStruct;
	CButton c_PPS;
	CEdit c_FrameRate;
	CEdit c_AspectRatio;
	CEdit c_MaxBitrate;
	CEdit c_NumRefFrames;
//	afx_msg void OnBnClickedCheck3();
	CString GetAppPath();
	CString cstrIniPath;
	CString cstrLogPath;

//	afx_msg void OnBnClickedOutputBtn();
	CButton c_FullLog;
	CButton c_LogToFile;
	CButton c_StartButton;
	CProgressCtrl c_Progress;
//	afx_msg void OnEnChangeEdit3();
	CEdit c_Level;
	
	CEdit c_Height;
	CEdit c_Width;
	CEdit c_Top;
	CEdit c_Bottom;
	CEdit c_CropTop;
	CEdit c_CropBottom;
	CEdit c_CropLeft;
	CEdit c_CropRight;
/*
	//afx_msg void OnBnClickedCancel();
	afx_msg void OnBnClickedAbort();
	afx_msg void OnBnClickedCheck8();
	afx_msg void OnBnClickedPps();
	afx_msg void OnDropFiles(HDROP hDropInfo);
	//void OnTimer( UINT_PTR nIDEvent );
	void OnTimer( UINT nIDEvent );
*/
	unsigned char* sei_buffer;
	unsigned char *payloadbuffer;
	unsigned char *lookaheadbuffer;
	unsigned char *slicebuffer;	

	CBitstream slice_bs; //making glob	

	void * memcpy_(void * dst, void const * src, size_t len);

	inline size_t buf_fread(unsigned char* ptr,  int count, FILE* stream){
		//PROFILE("buf_read");
		int count2 = 0;
		__int64_t readbytes = 0;
		__int64_t count_fposbuffer = count+fposbuffer;
		CString cstrtemp;	
		if( buf_eof ) {
			if((count_fposbuffer) > (buf_size -2) )
				readbytes = 0;
		}
		else if( buf_size == 0 ) {
			//fposfile += buf_size;
			buf_size =  fread( buf_fbuffer, sizeof(unsigned char), MAX_BUFFER, stream );				
		}
		
		//if(fposbuffer > 32765)
		//	count2 = 0; // fix temp

		if( (count_fposbuffer) >= buf_size ) {		
			count2 = buf_size-fposbuffer; 
			memcpy( ptr, buf_fbuffer+fposbuffer, count2 );
			readbytes += count2;
			count -= count2; //buf_size-fposbuffer
			fposfile += buf_size;
			fposbuffer = 0; 
			buf_size = fread( buf_fbuffer, sizeof(unsigned char), MAX_BUFFER, stream);			
			if(buf_size < MAX_BUFFER) buf_eof = true;
		}
		if( buf_size > 0 ) {
			if( count > 0 ) {			
				memcpy( ptr+count2 , buf_fbuffer+fposbuffer, count );
				fposbuffer += count;
				readbytes += count;
			}
			return (readbytes< 1) ? 0 : readbytes;
		}
		
		return 0;
	}

};
